diff --git a/lib/asn1/c_src/asn1_erl_nif.c b/lib/asn1/c_src/asn1_erl_nif.c
index b3dd312..eeb716b 100644
--- a/lib/asn1/c_src/asn1_erl_nif.c
+++ b/lib/asn1/c_src/asn1_erl_nif.c
@@ -967,16 +967,19 @@ int ber_decode_value(ErlNifEnv* env, ERL_NIF_TERM *value, unsigned char *in_buf,
     (*ib_index)++;
     if (indef == 1) { /* in this case it is desireably to check that indefinite length
      end bytes exist in inbuffer */
+        if (form != ASN1_CONSTRUCTED)
+	  return ASN1_INDEF_LEN_ERROR;
 	curr_head = enif_make_list(env, 0);
+	if ((*ib_index +1) >= in_buf_len)
+	  return ASN1_INDEF_LEN_ERROR;
 	while (!(in_buf[*ib_index] == 0 && in_buf[*ib_index + 1] == 0)) {
-	    if (*ib_index >= in_buf_len)
-		return ASN1_INDEF_LEN_ERROR;
-
 	    if ((maybe_ret = ber_decode(env, &term, in_buf, ib_index, in_buf_len))
 		    <= ASN1_ERROR
 		    )
 		return maybe_ret;
 	    curr_head = enif_make_list_cell(env, term, curr_head);
+	    if ((*ib_index +1) >= in_buf_len)
+	      return ASN1_INDEF_LEN_ERROR;
 	}
 	enif_make_reverse_list(env, curr_head, value);
 	(*ib_index) += 2; /* skip the indefinite length end bytes */
